package es2;

import java.util.ArrayList;

public class ListaDiAttesa {
	private final ArrayList<Cliente> list;
	
	public ListaDiAttesa() {
		list = new ArrayList<>();
	}
	
	public boolean isWaiting (Cliente c) {
		if (c==null) return false; //per efficienza meglio scrivere questa riga
		for (Cliente cLista:list) {
			//assumo che cLista sia diverso da null in quanto il metodo add che scriver dopo
			//non aggiunge mai elementi null all'arraylist
			if (cLista.equals(c)) return true;
		}
		return false;
	}
	
	public void add (Cliente c) {
		if (c==null) return;
		if (isWaiting(c)) return;
		list.add(c);		
	}
	
	public Cliente[] extract (int n) {
		if (n<0) return null;
		if (n>list.size()) n=list.size();
		Cliente[] ris = new Cliente[n];
		for (int i=0; i<n; i++) {
			ris[i] = list.remove(0);
			//[A,B,C,E,H] --> [B,C,E,H] 
		}
		return ris;		
	}
	
	public int size() {
		return list.size();
	}

}
